<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.2"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ADCS-Hardware-in-the-Loop: orbit.Orbit Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="TUDSaT_.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ADCS-Hardware-in-the-Loop<span id="projectnumber">&#160;0.0</span>
   </div>
   <div id="projectbrief">This is a hardware in the Loop</div>
  </td>
    <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.svg"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.svg" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.2 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('classorbit_1_1_orbit.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classorbit_1_1_orbit-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">orbit.Orbit Class Reference</div></div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for orbit.Orbit:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classorbit_1_1_orbit.png" alt=""/>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad47ef9d9b2af884e01385b7285b9499c"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#ad47ef9d9b2af884e01385b7285b9499c">__init__</a> (self, str <a class="el" href="classorbit_1_1_orbit.html#a09e490a4511400f7f6775955e46e129c">database</a>, float <a class="el" href="classorbit_1_1_orbit.html#aea02cef639dae5e74400fe0e919e2d4e">sampling_rate</a>, tuple epoch, float a, float i, float e, float argpo, float RAAN, outputs, float mean_anomaly=0.0, bool deg=True)</td></tr>
<tr class="separator:ad47ef9d9b2af884e01385b7285b9499c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92342e66feded39d21d9da4ac6227d16"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#a92342e66feded39d21d9da4ac6227d16">output</a> (self, sim_time, bool commit=True)</td></tr>
<tr class="separator:a92342e66feded39d21d9da4ac6227d16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17b8318de189b9488317581eb26a8a87"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#a17b8318de189b9488317581eb26a8a87">run</a> (self)</td></tr>
<tr class="separator:a17b8318de189b9488317581eb26a8a87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13a033c058b1c6937d44ade2c9e311f0"><td class="memItemLeft" align="right" valign="top">def&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#a13a033c058b1c6937d44ade2c9e311f0">propagate_orbit</a> (self, float <a class="el" href="namespaceorbit.html#a9fd1e9fc1c4041e086879370f2ef3ee6">max_time</a>)</td></tr>
<tr class="separator:a13a033c058b1c6937d44ade2c9e311f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-attribs" name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a09e490a4511400f7f6775955e46e129c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#a09e490a4511400f7f6775955e46e129c">database</a></td></tr>
<tr class="separator:a09e490a4511400f7f6775955e46e129c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aea02cef639dae5e74400fe0e919e2d4e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#aea02cef639dae5e74400fe0e919e2d4e">sampling_rate</a></td></tr>
<tr class="separator:aea02cef639dae5e74400fe0e919e2d4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5daa8bdcaac588994396d4903b5e814"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#aa5daa8bdcaac588994396d4903b5e814">sim_time_offset</a></td></tr>
<tr class="separator:aa5daa8bdcaac588994396d4903b5e814"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5813dcc79001a50a2abc7139f5b2234d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classorbit_1_1_orbit.html#a5813dcc79001a50a2abc7139f5b2234d">dict_orbit</a></td></tr>
<tr class="separator:a5813dcc79001a50a2abc7139f5b2234d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad47ef9d9b2af884e01385b7285b9499c" name="ad47ef9d9b2af884e01385b7285b9499c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad47ef9d9b2af884e01385b7285b9499c">&#9670;&nbsp;</a></span>__init__()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def orbit.Orbit.__init__ </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>self</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">str&#160;</td>
          <td class="paramname"><em>database</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sampling_rate</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">tuple&#160;</td>
          <td class="paramname"><em>epoch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>i</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>e</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>argpo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>RAAN</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>outputs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float &#160;</td>
          <td class="paramname"><em>mean_anomaly</em> = <code>0.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &#160;</td>
          <td class="paramname"><em>deg</em> = <code>True</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Class of a sgp4 orbit that can be initialized with Kepler elements rather than TLEs. Might be useless if
we decide to let the user define TLEs instead of Kepler elements.

@param database: (str) the database the orbit is connected with and is sending data to
@param sampling_rate: (float) the sampling rate (real time) that the propagator is supposed to compute a value
                        in Hz
@param epoch: (tuple) the epoch that all Kepler elements are referring to, Form: (yyyy, m, d, h, m, s)
@param a: (float) semi-major axis of the orbit in km
@param i: (float) inclination of the orbit in deg or rad -&gt; default is deg
@param e: (float) eccentricity of the orbit -&gt; must be between 0 and 1
@param argpo: (float) argument of perigee of the orbit in deg or rad -&gt; default is deg
@param RAAN: (float) right ascension of ascending node of the orbit in deg or rad -&gt; default is deg
@param mean_anomaly: (float) mean anomaly at the given epoch in deg or rad -&gt; default is deg
@param deg: (bool) indicate whether angles are given in deg or rad
</pre> 
</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a92342e66feded39d21d9da4ac6227d16" name="a92342e66feded39d21d9da4ac6227d16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a92342e66feded39d21d9da4ac6227d16">&#9670;&nbsp;</a></span>output()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def orbit.Orbit.output </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>self</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>sim_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool &#160;</td>
          <td class="paramname"><em>commit</em> = <code>True</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Computes the position and velocity vector of the orbit at a given time epoch and writes it to the
database.

:param sim_time: (float) the simulation time that has been passed since start of the simulation (NOT REAL TIME!)
:param commit: (bool) if True, computed vectors are committed to database, if False, computed vectors are
                        returned
:return: (list, list) returns position and velocity vector if commit is False
</pre> 
</div>
</div>
<a id="a13a033c058b1c6937d44ade2c9e311f0" name="a13a033c058b1c6937d44ade2c9e311f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13a033c058b1c6937d44ade2c9e311f0">&#9670;&nbsp;</a></span>propagate_orbit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def orbit.Orbit.propagate_orbit </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>self</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max_time</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Propagates an orbit trajactory for the time beginning with the simulation offset indicated when initializing
the orbit until the maximum time that needs to be specified in seconds. The frequency allows to adjust the
level of detail of the orbit trajectory. The more detailed the orbit is required, the higher the frequency has
to be set. After having fully propagated the orbit, it is written into the database.

:param max_time: (float) the duration of the propagated orbit in seconds
:param freq: (float) the frequency of the orbit in Hz
</pre> 
</div>
</div>
<a id="a17b8318de189b9488317581eb26a8a87" name="a17b8318de189b9488317581eb26a8a87"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a17b8318de189b9488317581eb26a8a87">&#9670;&nbsp;</a></span>run()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">def orbit.Orbit.run </td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname"><em>self</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">Runs the orbit simulation. Uses a while True loop with no abort option -&gt; should be adapted.
sim_time_factor is for scaling the real time to simulation time. With a sim_time_factor of 2 e.g. the simulation
time passes twice as fast as the real time. Therefore, the sampling_rate of the simulation time is actually
only half the sampling_rate that refers to the real time and that is given to the constructor.
</pre> 
</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a09e490a4511400f7f6775955e46e129c" name="a09e490a4511400f7f6775955e46e129c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a09e490a4511400f7f6775955e46e129c">&#9670;&nbsp;</a></span>database</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">orbit.Orbit.database</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a5813dcc79001a50a2abc7139f5b2234d" name="a5813dcc79001a50a2abc7139f5b2234d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5813dcc79001a50a2abc7139f5b2234d">&#9670;&nbsp;</a></span>dict_orbit</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">orbit.Orbit.dict_orbit</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aea02cef639dae5e74400fe0e919e2d4e" name="aea02cef639dae5e74400fe0e919e2d4e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aea02cef639dae5e74400fe0e919e2d4e">&#9670;&nbsp;</a></span>sampling_rate</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">orbit.Orbit.sampling_rate</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aa5daa8bdcaac588994396d4903b5e814" name="aa5daa8bdcaac588994396d4903b5e814"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5daa8bdcaac588994396d4903b5e814">&#9670;&nbsp;</a></span>sim_time_offset</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">orbit.Orbit.sim_time_offset</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="orbit_8py.html">orbit.py</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceorbit.html">orbit</a></li><li class="navelem"><a class="el" href="classorbit_1_1_orbit.html">Orbit</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.2 </li>
  </ul>
</div>
</body>
</html>
